<?php
/**
# SNS에 글 보내는 단추 달기 1.23 (텍스트큐브 확장기능)
# 만든이 : 팥빙산 (pat@pat.im)
# 만들이 블로그 : http:/pat.im
# 마지막으로 고친 날 : 2011. 7. 13
**/

/* *** <head>~</head> 안에 본문에 넣을 단추의 CSS를 끼워넣는다. *** */
function SNS_icons_header_content($target) {

	global $configVal, $entry;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) SNS_icons_initial_config($data);
	
	$context = Model_Context::getInstance();
	$blog_id = $context->getProperty('blog.id');
	$blogURL = $context->getProperty('uri.blog');
	$blog_title = $context->getProperty('blog.title');
	$defaultURL = $context->getProperty('uri.default');

	if($data['beginning_length']) $beginning_length = $data['beginning_length'];
	else $beginning_length = 150;
	$beginning = UTF8::lessenAsEm(removeAllTags(stripHTML($entry['content'])), $beginning_length);
	
	$header = CRLF;

	if($data['meta_blog_title'] && !empty($entry['title']))
		$header .= '<meta property="og:site_name" content="'.$blog_title.'"/>';

	if($data['meta_post_title'] && !empty($entry['title'])) {
		$header .= '<meta name="title" content="'.$entry['title'].'" />'.CRLF;
		//$header .= '<meta property="og:title" content="'.$entry['title'].'" />'.CRLF;
	}

	if($data['meta_description'] && !empty($beginning))
		$header .= '<meta name="Description" content="'.$beginning.'" />'.CRLF;

	if($data['image_src']) {		// 글에 붙인 그림 하나를 미리보기 그림(thumbnail)로 알린다.
		if(preg_match("/\[##_(1R|1L|1C|2C|3C|iMazing|Gallery)\|([^|]*)\.(gif|jpg|jpeg|png|bmp)\|.*_##\]/i", $entry['content'], $matches)) {
			$img_link = $defaultURL."/attach/".$blog_id."/".$matches[2].".".$matches[3];
			$header .= '<meta property="og:image" content="'.$img_link.'" />'.CRLF;
		}
		else if(preg_match("/\<img[^>]+?src=(\"(.*?)\"|'(.*?)').*\>/i", $entry['content'], $matches)) {
			$img_link = $matches[2];
			if(substr($img_link,0,7) != "http://" && substr($img_link,0,8) != "https://" && substr($img_link,0,2) == "//") {
				$img_link = $defaultURL.(subsur($img_link,0,1) == "/" ? "" : "/").$img_link;
			}
			$header .= '<meta property="og:image" href="'.$img_link.'" />'.CRLF;
		}
	}

	$header .= "<style type=\"text/css\">".CRLF;
	$position_array = array("onTop", "onBottom", "onSidebar", "onTag");
	foreach($position_array as $position) {
		if($data[$position.'_css'] && ($data[$position] || substr($position,-7,7)=="Sidebar" || substr($position,-3,3)=="Tag"))
			$header .= SNS_icons_stylesheet($position).CRLF;
	}
	$header .= "</style>".CRLF;
	$target = $target.$header;

	return $target;
}

function SNS_icons_footer_content($target) {

	global $configVal, $entries;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) SNS_icons_initial_config($data);
	if( ($data['onTop'] && $data['onTop_more']) || ($data['onBottom'] && $data['onBottom_more'])/* || $data['onTag_more'] || $data['onSidebar_more'] */) {
		$footer .= '<script type="text/javascript">'.CRLF;
		$footer .= '//<![CDATA['.CRLF;
		$footer .= "function getOffsetTop(obj) { return obj ? obj.offsetTop + getOffsetTop(obj.offsetParent) : 0; }".CRLF;
		$footer .= "function getOffsetLeft(obj) { return obj ? obj.offsetLeft + getOffsetLeft(obj.offsetParent) : 0; }".CRLF;
		$footer .= '//]]>'.CRLF;
		$footer .= '</script>'.CRLF;
		for($i=0; $i<=count($entries); ++$i) $footer .= more_script($entries[$i]['id']);
	}
	$target .= $footer;
	return $target;
}

function more_script($entry_id) {

	global $configVal, $pluginURL;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) SNS_icons_initial_config($data);

	$x_item_num = $data['more_x_item_num'] > 0 ? $data['more_x_item_num'] : 2;		// 더 보기 가로 항목 수
	$sidename_width = $data['more_item_name_width'] > 0 ? $data['more_item_name_width'] : 100;		// 더 보기 항목 이름 가로 폭
	$icon_size = 16;		// 더 보기 쪽그림 크기
	$icon_wrap_margin_side = 6;		// 쪽그림 좌우 여백
	$sidename_margin_left = 4;		// 이름 좌우 여백
	$width = ($icon_size + $icon_wrap_margin_side*2 + $sidename_width + $sidename_margin_left) * $x_item_num;

	$border = 3;		// 더 보기 창 테두리 굵기
	
	$context = Model_Context::getInstance();
	$defaultURL = $context->getProperty('uri.default');
	$icon_path = empty($data['icon_path']) || $data['icon_path'] == "http://" ? $defaultURL.$pluginURL."/images" : $data['icon_path'];
	$icon_path .= "/icons_16x16.png";
	
	$innerHTML = '<div class=\\"SNS_more_icon_header\\" style=\\"display:inline-block; width:100%; background:#DDD; margin:0; color:#333; font-size:12px;\\">';
	$innerHTML .= '<span class=\\"title\\" style=\\"padding:0 3px; float:left;\\">글 보내기</span>';
	$innerHTML .= '<span class=\\"close\\" onclick=\\"SNS_icons_more_layer'.$entry_id.'(this.parentNode.parentNode, this.parentNode.parentNode.entry_id, this.parentNode.parentNode.position_name);\\" style=\\"padding:0 3px; float:right;cursor:pointer; font-weight:bold;\\">닫기</span>';
	$innerHTML .= '</div>';

	$innerHTML .= '<div class=\\"SNS_more_icon_list\\" style=\\"padding:3px 0; margin:0; line-height:1em;\\">';

	SNS_link_array($link, $entry_id);
	icon_name_array($icon_name_array);
	$j = -1;
	foreach($icon_name_array['category'] as $category) {
		++$j;
		if($category == "more") continue;
		$i = -1;
		foreach($icon_name_array[$category]['name'] as $name) {
			++$i;

			$sidename = $icon_name_array[$category][$name]['sidename'];
			if(is_null($sidename)) continue;
			
			$onclick = str_replace("\"", "\\\"",$link[$name]['onclick']);
			$onclick .=  "SNS_icons_more_layer".$entry_id."(this.parentNode.parentNode, this.parentNode.parentNode.entry_id, this.parentNode.parentNode.position_name);";
			$innerHTML .= '<div class=\\"SNS_more_icon_wrap\\" onclick=\\"'.$onclick.'\\" onmouseover=\\"this.style.background=\'#ddc\';\\" onmouseout=\\"this.style.background=\'none\';\\" style=\\"font-size:12px; cursor:pointer; margin: 0; padding:3px '.$icon_wrap_margin_side.'px; display:'.(strpos($_SERVER['HTTP_USER_AGENT'], "MSIE") && preg_match("/MSIE (?P<version>\d+)/", $_SERVER['HTTP_USER_AGENT'], $browser) && $browser['version'] < 8 ? 'inline' : 'inline-block').';\\">';
			$innerHTML .= '<span class=\\"'.$name.'\\" style=\\"padding:0; vertical-align:middle; display:inline-block; padding:0; width:'.$icon_size.'px; height:'.$icon_size.'px; background: url(\''.$icon_path.'\') '.(-$i*16).'px '.(-$j*16).'px;\\"></span>';
			$innerHTML .= '<span style=\\"padding-left:'.$sidename_margin_left.'px; margin 0; width:'.$sidename_width.'px; vertical-align:middle; text-align:left; display:inline-block;\\">'.$sidename.'</span>';
			$innerHTML .= '</div>';
		}
	}
	$innerHTML .= '</div>';		// icon_list
	$innerHTML .= '<div class=\\"SNS_more_icon_footer\\" style=\\"display:inline-block; width:100%; background:#ddd !important; margin:0; padding:0; color #333; font-size:12px;\\">';
	$innerHTML .= '<span style=\\"margin:0; padding:0 3px; float:left;\\">&nbsp;</span>';
	$innerHTML .= '<span class=\\"author\\" style=\\"margin:0; padding:0 3px; float:right; cursor:pointer;\\"><a href=\\"http://pat.im/tag/SNS_icons\\" target=\\"_blank\\" style=\\"font-size:12px; font-weight:bold; color: #333; border:none;\\">v1.23</a></span>';
	$innerHTML .= '</div>';


	$position_array = array("onTop", "onBottom", "onSidebar", "onTag");
	foreach($position_array as $position) {
		if($data[$position.'_more'] && $data[$position]) {
			$content = CRLF;
			$content .= '<script type="text/javascript">'.CRLF;
			$content .= '//<![CDATA['.CRLF;

			$content .= "function SNS_icons_more_layer".$entry_id."(anchor, entry_id, icon_position) {".CRLF;
			$content .= "	idName = 'SNS_icons_more_' + entry_id + '_' + icon_position;".CRLF;
			$content .= "	var layer = document.getElementById(idName);".CRLF;
			$content .= "		layer.style.top = (getOffsetTop(anchor) + anchor.offsetHeight) + 'px';".CRLF;
			$content .= "		layer.style.left = (getOffsetLeft(anchor) ".($data['more_x_correction'] ? "+ (".$data['more_x_correction'].") " : "").") + 'px';".CRLF;
			$content .= "	if(layer.style.display == 'inline-block') {layer.style.display = 'none';}".CRLF;
			$content .= "	else if(layer.style.display == 'none') {layer.style.display = 'inline-block';}".CRLF;
			$content .= " else {".CRLF;
			$content .= "		layer.entry_id = entry_id;".CRLF;
			$content .= "		layer.position_name = icon_position;".CRLF;
			$content .= "		layer.style.background = '#F0F0F0';".CRLF;
			$content .= "		layer.style.border = '".$border."px #999 solid';".CRLF;
			$content .= "		layer.style.color = '#000000';".CRLF;
			$content .= "		layer.style.margin = '0px';".CRLF;
			$content .= "		layer.style.width = '".$width."px';".CRLF;
			$content .= "		layer.style.position = 'absolute';".CRLF;
			$content .= "		layer.innerHTML = \"".$innerHTML."\";".CRLF;	
			$content .= "		layer.style.display = 'inline-block';".CRLF;
			$content .= "	}".CRLF;
			$content .= "}".CRLF;

			$content .= '//]]>'.CRLF;
			$content .= '</script>'.CRLF;
			break;
		}
	}
	return $content;
}


/* *** 위치에 맞추어 단추의 CSS 내용을 돌려 준다. *** */
function SNS_icons_stylesheet($position) {

	global $pluginURL, $configVal, $pluginName;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) SNS_icons_initial_config($data);

	if(empty($pluginURL)) $pluginURL = "/plugins/SNS_icons";	// 본문에 치환자가 들어 있을 때 나타나는 오류 방지

	$context = Model_Context::getInstance();
	$defaultURL = $context->getProperty('uri.default');

	$type = $data[$position.'_type'];		// 단추 모양
	$align = $data[$position.'_align'];		// 가로 정렬
	$icon_type = $data[$position.'_type'] == "text" ? $icon_type = "button" : $icon_type = "span";

	preg_match("/(?P<size>\d+)($|(?P<unit>\w+))/", $data[$position.'_margin_top'], $margin_top);		// 여백의 크기와 단위를 뽑는다.
	preg_match("/(?P<size>\d+)($|(?P<unit>\w+))/", $data[$position.'_margin_bottom'], $margin_bottom);
	preg_match("/(?P<size>\d+)($|(?P<unit>\w+))/", $data[$position.'_margin_left'], $margin_left);
	preg_match("/(?P<size>\d+)($|(?P<unit>\w+))/", $data[$position.'_margin_right'], $margin_right);
	preg_match("/(?P<size>\d+)($|(?P<unit>\w+))/", $data[$position.'_icon_interval'], $icon_interval);
	preg_match("/(?P<size>\d+)($|(?P<unit>\w+))/", $data[$position.'_icon_line_height'], $icon_line_height);
	preg_match("/(?P<size>\d+)($|(?P<unit>\w+))/", $data[$position.'_sidename_width'], $icon_sidename_width);

	if(empty($margin_top['unit'])) $margin_top['unit'] = "px";
	if(empty($margin_bottom['unit'])) $margin_bottom['unit'] = "px";
	if(empty($margin_left['unit'])) $margin_left['unit'] = "px";
	if(empty($margin_right['unit'])) $margin_right['unit'] = "px";
	if(empty($icon_interval['unit'])) $icon_interval['unit'] = "px";
	if(empty($icon_line_height['unit'])) $icon_line_height['unit'] = "px";
	if(empty($icon_sidename_width['unit'])) $icon_sidename_width['unit'] = "px";

	if(empty($margin_top['size'])) $margin_top['size'] = "0";
	if(empty($margin_bottom['size'])) $imargin_bottom['size'] = "0";
	if(empty($margin_left['size'])) $margin_left['size'] = "0";
	if(empty($margin_right['size'])) $margin_right['size'] = "0";
	if(empty($icon_interval['size'])) $icon_interval['unit'] = "0";
	if(empty($icon_line_height['size'])) $icon_line_height['unit'] = "0";
	if(empty($icon_sidename_width['size'])) $icon_sidename_width['unit'] = "0";

	if($align=="right") { $icon_margin_left = $icon_interval['size']; $icon_margin_right = 0;}		// 가로 정렬 방식에 맞게 단추 간격을 정한다.
	else if($align=="left") {$icon_margin_right = $icon_interval['size']; $icon_margin_left = 0;}
	else {
			$icon_margin_left = (int)($icon_interval['size']/2);
			$icon_margin_right = (int)($icon_interval['size']/2) + $icon_interval['size']%2;
	}

	$position_class = ".SNS_icons_".$position;

	$header .= $position_class." {";
	if($align != "none") $header .= "text-align:".$align.";";
	$header .= "margin:".$margin_top['size'].$margin_top['unit']." ".$margin_right['size'].$margin_right['unit']." ".$margin_bottom['size'].$margin_bottom['unit']." ".$margin_left['size'].$margin_left['unit'].";";
	$header .= "}";

	preg_match("/(?P<width>\d+)x(?P<height>\d+)/", $type, $icon_size);

	$header .= $position_class." .icon_wrap {";
	$header .= "cursor:pointer;";
	if($icon_margin_left) $header .= "margin-left:".$icon_margin_left.$icon_interval['unit'].";";
	if($icon_margin_right) $header .= "margin-right:".$icon_margin_right.$icon_interval['unit'].";";
	$header .= "}";

	if($type == "text") {
		$header .= $position_class." .icon_wrap {";
		$header .= "display:inline;";
		$header .= "}";
		$header .= $position_class." .icon_wrap ".$icon_type." {";
		$header .= "display:inline;";
		if($icon_line_height['size']) $header .= "margin-bottom:".$icon_line_height['size'].$icon_line_height['unit']." !important;";		
		$header .= "}";
		return $header;
	}

	$header .= $position_class." .icon_wrap {";
	if($data[$position.'_sidename_position'] == "bottom") {
		$header .= "display:inline-block;";
		$header .= "vertical-align:top;";
		$header .= "text-align:center;";
		if($icon_line_height['size']) $header .= "margin-bottom:".$icon_line_height['size'].$icon_line_height['unit']." !important;";
	} else {
		$header .= "width:".$icon_size['width']."px;";
		$header .= "display:inline;";
	}
	$header .= "}";

	$header .= $position_class." .icon_wrap ".$icon_type." {";
	$header .= "border:0;";
	$header .= "cursor:pointer;";
	if($data[$position.'_sidename_position'] == "bottom") {
		$header .= "display:block;";
		$header .= "margin-left:auto;";
		$header .= "margin-right:auto;";
	}	else {
		$header .= "display:inline-block;";
		if($icon_line_height['size']) $header .= "margin-bottom:".$icon_line_height['size'].$icon_line_height['unit']." !important;";
	}

	$header .= "width:".$icon_size['width']."px;";
	$header .= "height:".$icon_size['height']."px;";
	$header .= "}";

	if($data[$position.'_sidename_position'] != "none" || !$data[$position.'_sidename_position']) {			// 쪽그림에 이름을 붙일 때
		$header .= $position_class." span.sidename {";
		$header .= "cursor:pointer;";
		$header .= "text-align:center;";		
		$header .= "font:".$data[$position.'_sidename_font_size']."px dotum;";
		if($data[$position.'_sidename_font_color']) $header .= "color:#".$data[$position.'_sidename_font_color'].";";
		$header .= "background:none!important;";
		if($icon_sidename_width['size']) $header .= "width:".$icon_sidename_width['size'].$icon_sidename_width['unit']."!important;";
		else $header .= "width:auto!important;";

		if($data[$position.'_sidename_position'] == "bottom") {
			$header .= "height:auto !important;";
			$header .= "margin-top:".$data[$position.'_sidename_margin']."px;";
		} else {
			$header .= "display:inline-block;";
			$header .= "margin-top:".round(($icon_size['height']-$data[$position.'_sidename_font_size'])/2)."px;";
			$header .= "margin-left:".($data[$position.'_sidename_margin'])."px;";
			$header .= "vertical-align:top;";
			$header .= "text-align:left;";
		}
		$header .= "}";
	}

	if(strpos($_SERVER['HTTP_USER_AGENT'], "MSIE")) {
		preg_match("/MSIE (?P<version>\d+)/", $_SERVER['HTTP_USER_AGENT'], $browser);
		if($browser['version'] < 8) {		// IE 7 이하일 때
			$header .= $position_class." .icon_wrap {";
			if($data[$position.'_sidename_position'] == "bottom") {
				if($icon_sidename_width['size'] > $icon_size['width']) $header .= "width:".$icon_sidename_width['size'].$icon_sidename_width['unit']." !important;";
				else $header .= "width:".$icon_size['width']."px;";
			} else $header .= "width:auto;";
			$header .= "display:inline;";
			$header .= "}";
		}
	}

	icon_name_array($icon_name_array);

	$j = -1;
	foreach($icon_name_array['category'] as $category) {
		++$j;
		if(!count($icon_name_array[$category]['name'])) continue;
		$i = 0;
		foreach($icon_name_array[$category]['name'] as $name) {
			if($data[$position."_".$name]) {
				$header .= $position_class." .icon_wrap .".$name." {";
				$icon_path = empty($data['icon_path']) || $data['icon_path'] == "http://" ? $defaultURL.$pluginURL."/images" : $data['icon_path'];
				$icon_path .= "/icons_".$icon_size['width']."x".$icon_size['height'].".png";
				$header .= "background:url('".$icon_path."') ".(-$i*$icon_size['width'])."px ".(-$j*$icon_size['height'])."px;";
				$header .= "}";
			}
			++$i;
		}
	}

	return $header;
}

/* *** 위치에 맞게 글 보내는 단추의 HTML 내용을 돌려 준다. *** */
function show_SNS_icons($position, $entry_id) {

	global $blog, $configVal, $pluginURL;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) SNS_icons_initial_config($data);			// 설정값이 없으면 기본값을 넣는다.

	$context = Model_Context::getInstance();
	$defaultURL = $context->getProperty('uri.default');
	$blog_id = $context->getProperty('blog.id');
	$useEncodeURL = $context->getProperty('service.useEncodeURL');
	
	$DB_data = DBModel::getInstance();
	$DB_data->reset('Entries');
	$DB_data->setQualifier('blogid','eq',$blog_id);
	$DB_data->setQualifier('id','eq',$entry_id);
	$entry = $DB_data->getRow();

	$icon_type = $data[$position.'_type'] == "text" ? $icon_type = "button" : $icon_type = "span";

	$content = '<div class="SNS_icons_'.$position.'"'.'>';

	SNS_link_array($link, $entry_id);
	icon_name_array($icon_name_array);
	foreach($icon_name_array['category'] as $category) {
		$i = -1;
		foreach($icon_name_array[$category]['name'] as $name) {
			++$i;
			if(!$data[$position.'_'.$name] || !$link[$name]) continue;
			$balloon_name = $icon_name_array[$category][$name]['balloon_name'];
			$sidename = $icon_name_array[$category][$name]['sidename'];

			if($name == "more") $onclick = "SNS_icons_more_layer".$entry_id."(this,".$entry_id.",'".$position."');";
			else $onclick = $link[$name]['onclick'];	
			$content .= '<div title="'.$balloon_name.'" class="icon_wrap" onclick="'.$onclick.'">';
		
			$content .= '<'.$icon_type.' class="'.$name.'">';

			if($icon_type == "button") $content .= '<span>'.$sidename.'</span>';

			$content .= '</'.$icon_type.'>';
			if($data[$position.'_sidename_position'] != "none" && $icon_type != "button") $content .= '<span class="sidename">'.$sidename.'</span>';
			$content .= '</div>';
		}
	}

	$content .= "</div>".CRLF;
	if($data[$position.'_more']) $content .=	'<div id="SNS_icons_more_'.$entry['id'].'_'.$position.'" style="z-index:1000000;"></div>'.CRLF;

	return $content;
}


function SNS_link_array(&$link, $entry_id) {

	global $blog, $configVal, $pluginURL;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) SNS_icons_initial_config($data);			// 설정값이 없으면 기본값을 넣는다.

	$context = Model_Context::getInstance();
	$defaultURL = $context->getProperty('uri.default');
	$blog_id = $context->getProperty('blog.id');
	$useEncodeURL = $context->getProperty('service.useEncodeURL');
	
	$DB_data = DBModel::getInstance();
	$DB_data->reset('Entries');
	$DB_data->setQualifier('blogid','eq',$blog_id);
	$DB_data->setQualifier('id','eq',$entry_id);
	$entry = $DB_data->getRow();
	
	if($entry['id']) $original_url = $defaultURL."/".($blog['useSloganOnPost'] && $data['post_url']==1 ? "entry/".URL::encode($entry['slogan'], $useEncodeURL) : $entry['id']);		// 글 주소
	else $original_url = "http://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
	$encoded_original_url = rawurlencode($original_url);

	if($data['short_url'] == "other" && !empty($data['other_url'])) {
		if($entry['id']) $url = $data['other_url'].(substr($data['other_url'],-1,1)=="/" ? "" : "/").($blog['useSloganOnPost'] && $data['post_url']==1 ? "entry/".URL::encode($entry['slogan'], $useEncodeURL) : $entry['id']);		// 글 주소
		else $url = $data['other_url'].(substr($data['other_url'],-1,1)=="/" ? "" : "/").$_SERVER['REQUEST_URI'];
	} else $url = $original_url;

	$encoded_url = rawurlencode($url);

	$title = $entry['title'];
	$encoded_title = rawurlencode($title);

	if($data['beginning_length']) $beginning_length = $data['beginning_length'];
	else $beginning_length = 150;

	// 본문에 이 확장기능이 쓰는 치환자가 들었지는 확인하여 글이 나오지 않는 오류를 막는다.
	if(strpos($entry['content'],"[##_SNS_icons_##]")) $entry['content'] = str_replace("[##_SNS_icons_##]","",$entry['content']);
	if(strpos($entry['content'],"[##_SNS_account_icons_##]")) $entry['content'] = str_replace("[##_SNS_account_icons_##]","",$entry['content']);
	$text = htmlspecialchars(UTF8::lessenAsEm(removeAllTags(stripHTML($entry['content'])), $beginning_length));

	$encoded_text = rawurlencode($text);

	$tags_array = getTags($blog_id, $entry['id']);		// 글의 꼬리표를 따온다.
	foreach($tags_array as $tag) $tags .= $tag['name'].",";
	if(substr($tags,-1) == ",") $tags = substr($tags,0,-1);
	$encoded_tags = rawurlencode($tags);

	switch($data['twitter_link']) {			// 선택값에 따라 트위터에 넣을 글 주소(고유주소/단축주소)를 정한다.
		case 1:		// 블로그 고유 주소 또는 다른 짧은 주소 쓰기
			$link['twitter']['link'] = $defaultURL.$pluginURL."/tweet?text=".$encoded_title.rawurlencode(" ").$encoded_url;
			//$link['twitter']['link'] = "http://twitter.com/intent/tweet?original_referer=".$encoded_original_url."&amp;source=webclient&amp;text=".$encoded_title.rawurlencode(" ").$encoded_url;
			//$link['twitter']['link'] = "http://twitter.com/?status=".$encoded_title.rawurlencode(" ").$encoded_url;
			if($data['twitter_via_id']) $link['twitter']['link'] .= rawurlencode(" via @".$data['twitter_via_id']);
			break;
		case 2;		// 트위터 자체 주소(t.co) 쓰기
			if($entry['id']) $encoded_url_in_twitter = rawurlencode($defaultURL."/".$entry['id']);		// 블로그 숫자 주소로 연결함
			else $encoded_url_in_twitter = $encoded_original_url;
			$link['twitter']['link'] = "http://twitter.com/intent/tweet?original_referer=".$encoded_original_url."&amp;source=webclient&amp;text=".$encoded_title;
			$link['twitter']['link'] .= "&amp;url=".$encoded_url_in_twitter;
			if($data['twitter_id'] && $data['twitter_via']) $link['twitter']['link'] .= "&amp;via=".$data['twitter_id'];
			break;
	}

	$link['facebook']['link'] = "http://www.facebook.com/sharer.php?t=".$encoded_title."&amp;u=".$encoded_original_url;
	$link['me2day']['link'] = "http://me2day.net/posts/new?new_post[body]=".$encoded_title.urlencode(" \"").$encoded_url.urlencode("\":").$encoded_url."&amp;new_post[tags]=".$encoded_tags;
	$link['yozm']['link'] = "http://yozm.daum.net/home?m=".$encoded_title."%20".$encoded_url;
	//$link['yozm']['link'] = "http://yozm.daum.net/api/popup/prePost?sourceid=41&amp;link=".$encoded_url."&amp;prefix=".$encoded_title."+".$encoded_url;
	$link['connect']['link'] = "http://connect.nate.com/index.nate?msg=".$encoded_title."%20".$encoded_url;
	$link['c_empathy']['link'] = "http://csp.cyworld.com/bi/bi_recommend_pop.php?url=".$encoded_original_url."&amp;t=".$encoded_title;
	$link['tumblr']['link'] = "http://www.tumblr.com/share?v=3&amp;u=".$encoded_url."&amp;t=".$encoded_title;
	$link['myspace']['link'] = "http://www.myspace.com/Modules/PostTo/Pages/?l=1&amp;u=".$encoded_original_url."&amp;t=".$encoded_title;
	$link['google_bookmarks']['link'] = "http://www.google.com/bookmarks/mark?op=add&amp;bkmk=".$encoded_original_url."&amp;title=".$encoded_title."&amp;labels=".$encoded_tags."&amp;annotation=".$encoded_text;
	$link['naver_bookmark']['link'] = "http://bookmark.naver.com/post?m=post&amp;ns=1&amp;title=".$encoded_title."&amp;url=".$encoded_original_url;
	$link['yahoo_bookmarks']['link'] = "http://bookmarks.yahoo.com/toolbar/savebm?opener=tb&amp;t=".$encoded_title."&amp;d=".$encoded_text."&amp;u=".$encoded_original_url;
	$link['margarin']['link'] = "http://mar.gar.in/post/popup_post/&amp;qTitle=".($encoded_title)."&amp;qURL=".rawurlencode($encoded_original_url);
	$link['delicious']['link'] = "http://www.delicious.com/save?v=5&amp;noui&amp;jump=close&amp;url=".$encoded_original_url."&amp;title=".$encoded_title; //."&amp;tags=".$encoded_tags;
	$link['digg']['link'] = "http://digg.com/submit?phase=2&amp;url=".$encoded_original_url."&amp;title=".$encoded_title."&amp;bodytext=".$encoded_text;
	$link['google_reader']['link'] = "http://www.google.com/reader/link?url=".$encoded_original_url.'&amp;title='.$encoded_title;
	$link['hanrss']['link'] = "http://www.hanrss.com/bookmarks/add_link.qst?url=".$encoded_original_url.'&amp;title='.$encoded_title;
	$link['gmail']['link'] = "http://mail.google.com/mail/?ui=2&view=cm&fs=1&tf=1&su=".$encoded_title."&amp;body=".urlencode("글 주소: ").$encoded_original_url.urlencode("\n\n").$encoded_text;
	$link['hotmail']['link'] = "http://hotmail.com/secure/start?action=compose&subject=".$encoded_title."&amp;body=".urlencode("글 주소: ").$encoded_original_url.urlencode("\n\n").$encoded_text;
  $link['yahoo_mail']['link'] = "http://us.mg4.mail.yahoo.com/dc/launch?action=compose&amp;To=&Subj=".$encoded_title."&amp;Body=".urlencode("글 주소: ").$encoded_original_url.urlencode("\n\n").$encoded_text;

	$content = CRLF;

	icon_name_array($icon_name_array);
	foreach($icon_name_array['category'] as $category) {
		$i = -1;
		foreach($icon_name_array[$category]['name'] as $name) {
			++$i;
			$balloon_name = $icon_name_array[$category][$name]['balloon_name'];
			$sidename = $icon_name_array[$category][$name]['sidename'];
			$window_width = 780;
			$window_height = 510;
			if($name=="yozm" || $name=="me2day" || $name=="connect" || $name=="margarin") $window_width = 980;

			if($name == "more") $onclick = "";
			else if($data['short_url'] != "none" && $data['short_url'] != "other" && preg_match("/^(twitter|me2day|yozm)/",$name) && !($name=="twitter" && $data['twitter_link'] == 2))
				$onclick = "window.open('".$defaultURL.$pluginURL."/"."convert_to_shortURL.php?shortURL_domain=".$data['short_url']."&amp;linkURL=".urlencode($link[$name]['link'])."&amp;longURL=".$encoded_url."&amp;width=".$window_width."&amp;height=".$window_height."', '".$name."', 'width=".$window_width.", height=".$window_height.", resizable=1, scrollbars=1');";
			else $onclick = "window.open('".$link[$name]['link']."', '".$name."', 'width=".$window_width.", height=".$window_height.", resizable=1, scrollbars=1');";

			$link[$name]['onclick'] = $onclick;
		}
	}
}


/* ***	치환자 [##_SNS_icons_##]에 단추를 넣는다. *** */
function show_icons_onTag($target) {
	global $configVal, $entry;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) SNS_icons_initial_config($data);

	$tagContent .= show_SNS_icons("onTag", $entry['id']);
	if($data['onTag_more']) $tagContent .= more_script($entry['id']);

	return $tagContent;
}


/* ***	옆막대에 글 보내는 단추를 넣는다. *** */
function show_icons_onSidebar($parameter) {
	global $configVal, $entry;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) SNS_icons_initial_config($data);

	$sidebarContent .= show_SNS_icons("onSidebar", $entry['id']);
	if($data['onSidebar_more']) $sidebarContent .= more_script($entry['id']);

	return $sidebarContent;
}


/* ***	본문에 글 보내기 단추를 넣는다. *** */
function show_icons_onContent($target, $mother) {
	global $configVal, $entry;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) SNS_icons_initial_config($data);

	if(strpos($entry['content'],"[##_SNS_account_icons_##]")) $entry['content'] = str_replace("[##_SNS_account_icons_##]","",$entry['content']);

	$position_array = array("onTop", "onBottom");
	foreach($position_array as $position)
		if($data[$position]) $content[$position] .= show_SNS_icons($position, $mother);
	
	return $content['onTop'].$target.$content['onBottom'];
}


/* *** 환경설정값이 없으면 기본값으로 채운다. *** */
function SNS_icons_initial_config(&$data) {
	$data['beginning_length'] = 150;
	$data['short_url'] = "none";
	$data['other_url'] = "";
	$data['post_url'] = 1;
	$data['twitter_link'] = 1;

	$position_array = array("onTop", "onBottom", "onSidebar", "onTag");
	icon_name_array($icon_name_array);

	foreach($position_array as $position) {
		$data[$position.'_css'] = 1;
		$i=0;
		foreach($icon_name_array['category'] as $category) {
			$j=0;
			foreach($icon_name_array[$category]['name'] as $name) {
				if(!$i &&$j++<4) $data[$position.'_'.$name] = 1;
			}
			++$i;
		}
		$data[$position] = 0;
		$data[$position.'_type'] = "24x24";
		$data[$position.'_align'] = "right";
		$data[$position.'_icon_interval'] = "5";
		$data[$position.'_icon_line_height'] = "0";
		$data[$position.'_sidename_position'] = "none";
		$data[$position.'_sidename_font_size'] = "11";
		$data[$position.'_sidename_color'] = "";
		$data[$position.'_sidename_margin'] = "5";
		$data[$position.'_sidename_width'] = "0";
		$data[$position.'_margin_top'] = "10";
		$data[$position.'_margin_bottom'] = "10";
		$data[$position.'_margin_left'] = "0";
		$data[$position.'_margin_right'] = "0";
	}
	//$data['more_item'] = "all";
	$data['onBottom'] = 1;
}


/* *** SNS와 즐겨찾기 누리집의 이름을 넣는다. *** */
function icon_name_array(&$icon_name_array) {
	$icon_name_array['category'] = array("SNS", "bookmark", "media sharing", "RSS", "mail", "more");

	$icon_name_array['SNS']['name'] = array("twitter", "facebook", "yozm", "me2day", "connect", "c_empathy", "tumblr", "myspace");
	$balloon_name_array = array('twitter'=>"트위터에 보내기", 'facebook'=>"페이스북에 보내기", 'yozm'=>"요즘에 보내기", 'me2day'=>"미투데이에 보내기", 'connect'=>"커넥트에 보내기", 'c_empathy'=>"C공감에 보내기", 'tumblr'=>"텀블에 보내기", 'myspace'=>"마이스페이스에 보내기");
	$sidename_array = array('twitter'=>"트위터", 'facebook'=>"페이스북", 'yozm'=>"요즘", 'me2day'=>"미투데이", 'connect'=>"커넥트", 'c_empathy'=>"C공감", 'tumblr'=>"텀블", 'myspace'=>"마이스페이스");

	$icon_name_array['bookmark']['name'] = array("google_bookmarks", "naver_bookmark", "yahoo_bookmarks", "margarin", "delicious", "digg");
	$bookmark_balloon_name_array = array('google_bookmarks'=>"구글 즐겨찾기로 보내기", 'naver_bookmark'=>"네이버 즐겨찾기로 보내기", 'yahoo_bookmarks'=>"야후 즐겨찾기로 보내기", 'margarin'=>"마가린 바르기", 'delicious'=>"딜리셔스로 보내기", 'digg' => "디그로 보내기");
	$bookmark_sidename_array = array('google_bookmarks'=>"구글 즐겨찾기", 'naver_bookmark'=>"네이버 즐겨찾기", 'yahoo_bookmarks'=>"야후 즐겨찾기", 'margarin'=>"마가린", 'delicious'=>"딜리셔스", 'digg' => '디그');

	$icon_name_array['RSS']['name'] = array("", "", "google_reader", "hanrss");
	$RSS_balloon_name_array = array('hanrss'=>"한RSS", 'google_reader'=>"구글 구독기로 보내기");
	$RSS_sidename_array = array('hanrss'=>"한RSS", 'google_reader'=>"구글 구독기");

	$icon_name_array['mail']['name'] = array("", "gmail", "hotmail", "yahoo_mail");
	$mail_balloon_name_array = array('gmail'=>"구글 편지로 보내기", 'hotmail'=>"호트메일로 보내기", 'yahoo_mail'=>"야후 편지로 보내기");
	$mail_sidename_array = array('gmail'=>"구글 편지", 'hotmail'=>"호트메일", 'yahoo_mail'=>"야후 편지");

	$icon_name_array['more']['name'] = array("more");
	$more_balloon_name_array = array('more'=>"더 보기");
	$more_sidename_array = array('more'=>"더 보기");

	foreach($icon_name_array['SNS']['name'] as $name)
		$icon_name_array['SNS'][$name] = array('balloon_name' => $balloon_name_array[$name], 'sidename' => $sidename_array[$name]);

	foreach($icon_name_array['bookmark']['name'] as $name)
		$icon_name_array['bookmark'][$name] = array('balloon_name' => $bookmark_balloon_name_array[$name], 'sidename' => $bookmark_sidename_array[$name]);
		
	foreach($icon_name_array['RSS']['name'] as $name)
		$icon_name_array['RSS'][$name] = array('balloon_name' => $RSS_balloon_name_array[$name], 'sidename' => $RSS_sidename_array[$name]);

	foreach($icon_name_array['mail']['name'] as $name)
		$icon_name_array['mail'][$name] = array('balloon_name' => $mail_balloon_name_array[$name], 'sidename' => $mail_sidename_array[$name]);

	foreach($icon_name_array['more']['name'] as $name)
		$icon_name_array['more'][$name] = array('balloon_name' => $more_balloon_name_array[$name], 'sidename' => $more_sidename_array[$name]);

}


function SNS_icons_Config($plugin) {

	icon_name_array($icon_name_array);

	$position_array = array("onTop", "onBottom", "onSidebar", "onTag");
	$position_name_array = array('onTop'=>"본문 위", 'onBottom'=>"본문 아래", 'onSidebar'=>"옆막대", 'onTag'=>"치환자");

	$manifest .= '<config dataValHandler = "SNS_icons_DataSet">'.CRLF;
	$manifest .= '	<window width="560" height="700" />'.CRLF;
	$manifest .= '	<fieldset legend="CSS 설정">'.CRLF;
	$manifest .= '		<field title="CSS 넣기 :" type="checkbox" name="SNS_icon_css">'.CRLF;
	foreach($position_array as $position) {
		$manifest .= '			<op name="'.$position.'_css" value="1" checked="checked"><![CDATA['.$position_name_array[$position].']]></op>'.CRLF;
		if($position == "onTag") break;
	}
	$manifest .= '			<caption><![CDATA[※ 갈매기표를 하지 않으면 아래의 단추 꾸밈 설정을 반영하는 CSS를 넣지 않습니다.]]></caption>';
	$manifest .= '		</field>'.CRLF;
	$manifest .= '	</fieldset>'.CRLF;

	$manifest .= '	<fieldset legend="글 보내기">'.CRLF;
	$manifest .= '		<field title="본문에 넣을 곳 :" type="checkbox" name="positions">'.CRLF;
	$manifest .= '			<op name="onTop" value="1"><![CDATA[본문 위]]></op>'.CRLF;
  $manifest .= '			<op name="onBottom" value="1" checked="checked"><![CDATA[본문 아래]]></op>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		<field title="메타 태그 넣기 :" type="checkbox" name="meta_info">'.CRLF;
	$manifest .= '			<op name="meta_blog_title" value="1"><![CDATA[블로그 이름]]></op>'.CRLF;
	$manifest .= '			<op name="meta_post_title" value="1"><![CDATA[글 제목]]></op>'.CRLF;
  $manifest .= '			<op name="meta_description" value="1"><![CDATA[글머리]]></op>'.CRLF;
  $manifest .= '			<op name="image_src" value="1"><![CDATA[페이스북 첫 그림 미리보기]]></op>'.CRLF;
 	$manifest .= '			<caption><![CDATA[';
	$manifest .= '			※ 메타 태그로 글 정보를 받는 페이스북, 디그에 글 정보를 알립니다.<br />'.CRLF;
	$manifest .= '			※ 그냥 두어도 잘 들어가는 정보의 메타 태그는 굳이 넣을 필요는 없습니다.'.CRLF;
	$manifest .= '			]]></caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		<field title="글머리 길이 (기본값:150) :" name="beginning_length" type="text" size="5" value="" titledirection="" />'.CRLF;
	$manifest .= '		<field title="연결할 글 주소 :" name="post_url" type="radio">'.CRLF;
	$manifest .= '			<op value="1" checked="checked"><![CDATA[공개 주소]]></op>'.CRLF;
	$manifest .= '			<op value="2"><![CDATA[숫자 주소]]></op>'.CRLF;
	$manifest .= '			<caption><![CDATA[';
	$manifest .= '			※ 숫자 주소를 고르면 문자 주소를 공개하더라도 숫자 주소로 잇습니다.<br />'.CRLF;
	$manifest .= '			]]></caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		<field title="짧은 주소 :" name="short_url" type="select">'.CRLF;
	$manifest .= '			<op value="none" checked="checked"><![CDATA[쓰지 않음]]></op>'.CRLF;
	$manifest .= '			<op value="other"><![CDATA[다른 주소]]></op>'.CRLF;
	$manifest .= '			<op value="bit.ly"><![CDATA[bit.ly]]></op>'.CRLF;
	$manifest .= '			<op value="j.mp"><![CDATA[j.mp]]></op>'.CRLF;
	$manifest .= '			<op value="is.gd"><![CDATA[is.gd]]></op>'.CRLF;
	$manifest .= '			<op value="v.gd"><![CDATA[v.gd]]></op>'.CRLF;
	$manifest .= '			<op value="to.ly"><![CDATA[to.ly]]></op>'.CRLF;
	$manifest .= '			<op value="dok.do"><![CDATA[dok.do]]></op>'.CRLF;
	$manifest .= '			<op value="goo.gl"><![CDATA[goo.gl]]></op>'.CRLF;
	$manifest .= '			<op value="durl.me"><![CDATA[durl.me]]></op>'.CRLF;
	$manifest .= '			<caption><![CDATA[※ 짧은 주소는 글짜 수를 제한하는 쪽글에 들어갑니다.]]></caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		<field title="다른 주소 :" name="other_url" type="text" size="25" value="">'.CRLF;
	$manifest .= '			<caption><![CDATA[※ 다른 주소는 블로그 기본 주소만 갈음하고 나머지 글 주소는 그대로 씁니다.<br />※ 다른 도메인 주소는 http://를 생략하지 않아야 합니다.]]></caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;	

	$manifest .= '		<field title="트위터에 넣을 글 주소 :" name="twitter_link" type="radio">'.CRLF;
	$manifest .= '			<op value="1" checked="checked"><![CDATA[본래 주소/짧은 주소]]></op>'.CRLF;
	$manifest .= '			<op value="2"><![CDATA[트위터 주소(t.co)]]></op>'.CRLF;
	$manifest .= '			<caption><![CDATA[※ 본래 주소나 위에서 설정한 짧은 주소를 쓸 때는 내장한 입력기를 띄웁니다.<br />'.CRLF;
	$manifest .= '			※ 트위터 주소(t.co)를 쓸 때는 숫자 글 주소로 연결합니다.]]></caption>'.CRLF;;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		<field title="트위터 via 아이디 :" name="twitter_via_id" type="text" size="10" value="">'.CRLF;
	$manifest .= '			<caption><![CDATA[※ 트위터 via 아이디를 넣으면 뒤쪽에 \'via @아이디\'를 붙입니다.]]></caption>'.CRLF;;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '	</fieldset>'.CRLF;

	$manifest .= '	<fieldset legend="쪽그림 파일 경로">'.CRLF;
	$manifest .= '		<field title=" " name="icon_path" type="text" size="65" value="http://">'.CRLF;
	$manifest .= '			<caption><![CDATA[※ 다른 경로에서 쪽그림 파일을 불러오게 하여 전송량을 분산할 수 있습니다.<br />※ 비워 두면 /plugins/SNS_icons/images에서 쪽그림을 불러옵니다.]]></caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '	</fieldset>'.CRLF;

	$manifest .= '	<fieldset legend="더 보기">'.CRLF;
	$manifest .= '		<field title="가로 항목 수 :" name="more_x_item_num" type="text" size="2" value="2" titledirection="" />'.CRLF;
	$manifest .= '		<field title="항목 이름 가로 너비(px) :" name="more_item_name_width" type="text" size="3" value="100" titledirection="" />'.CRLF;
	$manifest .= '		<field title="가로 위치 조절(px) :" name="more_x_correction" type="text" size="4" value="" titledirection="" />'.CRLF;
	$manifest .= '	</fieldset>'.CRLF;

	foreach($position_array as $position) {
		$position_name = $position_name_array[$position];
		$manifest .= '	<fieldset legend="'.$position_name.' - 단추 꾸미기">'.CRLF;
		foreach($icon_name_array['category'] as $category) {
			if($category == "bookmark") $category_name = "즐겨찾기";
			else if($category == "media sharing") continue;
			else if($category == "mail") $category_name = "전자우편";
			else if($category == "RSS") $category_name = $category;
			else if($category == "more") break;
			else $category_name = $category;
			$manifest .= '		<field title="'.$category_name.' :" type="checkbox" name="buttons">'.CRLF;
			$i=0;
			foreach($icon_name_array[$category]['name'] as $name) {
				if(!$name) continue;
				$sidename = $icon_name_array[$category][$name]['sidename'];
				if($category == "bookmark") $sidename = str_replace($category_name, '', $sidename);
				$manifest .= '			<op name="'.$position.'_'.$name.'" value="1"'.($category=="SNS" && $i++<4 ? ' checked="checked"' : '').'><![CDATA['.$sidename.']]></op>'.CRLF;
			}
			$manifest .= '		</field>'.CRLF;
		}
		$manifest .= '		<field title="더 보기 :" type="checkbox" name="buttons">'.CRLF;
		$manifest .= '			<op name="'.$position.'_more" value="1" checked="checked"></op>'.CRLF;
		$manifest .= '		</field>'.CRLF;
		$manifest .= '		<field title="단추 크기/모양 :" name="'.$position.'_type" type="select">'.CRLF;
		$manifest .= '			<op value="32x32"><![CDATA[32x32 쪽그림]]></op>'.CRLF;
    $manifest .= '		  <op value="24x24" checked="checked"><![CDATA[24x24 쪽그림]]></op>'.CRLF;
    $manifest .= '			<op value="16x16"><![CDATA[16x16 쪽그림]]></op>'.CRLF;
 		//$manifest .= '			<op value="custom"><![CDATA[맞춤 설정]]></op>'.CRLF;
		$manifest .= '			<op value="text"><![CDATA[글 단추]]></op>'.CRLF;
		$manifest .= '		</field>'.CRLF;
		$manifest .= '		<field title="가로 정렬 :" name="'.$position.'_align" type="radio">'.CRLF;
		$manifest .= '			<op value="left"><![CDATA[왼쪽]]></op>'.CRLF;
    $manifest .= '	 		<op value="center"><![CDATA[가운데]]></op>'.CRLF;
		$manifest .= '			<op value="right" checked="checked"><![CDATA[오른쪽]]></op>'.CRLF;
		$manifest .= '			<op value="none"><![CDATA[정렬하지 않음]]></op>'.CRLF;
		$manifest .= '		</field>'.CRLF;
		$manifest .= '		<field title=": 단추 가로 간격" name="'.$position.'_icon_interval" type="text" size="4" value="5" titledirection="bk" />'.CRLF;
		$manifest .= '		<field title=": 단추 줄 간격" name="'.$position.'_icon_line_height" type="text" size="4" value="0" titledirection="bk" />'.CRLF;
		$manifest .= '		<field title="쪽그림 이름 :" name="'.$position.'_sidename_position" type="radio">'.CRLF;
		$manifest .= '			<op value="none" checked="checked"><![CDATA[넣지 않음]]></op>'.CRLF;
		$manifest .= '			<op value="right"><![CDATA[오른쪽]]></op>'.CRLF;
		$manifest .= '			<op value="bottom"><![CDATA[아래]]></op>'.CRLF;
		$manifest .= '		</field>'.CRLF;
		$manifest .= '		<field title="쪽그림 이름 글꼴 크기 :" name="'.$position.'_sidename_font_size" type="text" size="4" value="11" />'.CRLF;
		$manifest .= '		<field title="쪽그림 이름 글꼴 색 : #" name="'.$position.'_sidename_font_color" type="text" size="7" value="" />'.CRLF;
		$manifest .= '		<field title="쪽그림 이름 가로폭 :" name="'.$position.'_sidename_width" type="text" size="4" value="0" />'.CRLF;
		$manifest .= '		<field title="쪽그림과 이름 간격 :" name="'.$position.'_sidename_margin" type="text" size="4" value="5" />'.CRLF;
		$manifest .= '		<field title=": 위쪽 여백" name="'.$position.'_margin_top" type="text" size="5" value="10" titledirection="bk" />'.CRLF;
		$manifest .= '		<field title=": 아래쪽 여백" name="'.$position.'_margin_bottom" type="text" size="5" value="10" titledirection="bk" />'.CRLF;
		$manifest .= '		<field title=": 왼쪽 여백" name="'.$position.'_margin_left" type="text" size="5" value="0" titledirection="bk" />'.CRLF;
		$manifest .= '		<field title=": 오른쪽 여백" name="'.$position.'_margin_right" type="text" size="5" value="0" titledirection="bk">'.CRLF;
		$manifest .= '			<caption><![CDATA[※ 여백, 간격, 글꼴 크기에 단위(px, pt, mm, ...)를 넣지 않으면 px를 단위로 붙입니다.]]></caption>'.CRLF;
		$manifest .= '		</field>'.CRLF;

		$manifest .= '		<field title="'.$position_name.' - 단추 머리글 (Header)" name="'.$position.'_header" type="textarea" rows="3" cols="57">';
		if(substr($position,-7,7)=="Sidebar") $manifest .= '		<![CDATA[<div class="SNS_icons"><h3>SNS 계정</h3>]]>';
		$manifest .= '		</field>'.CRLF;
		$manifest .= '		<field title="'.$position_name.' - 단추 꼬리글 (Footer)" name="'.$position.'_footer" type="textarea" rows="2" cols="57">';
		if(substr($position,-7,7)=="Sidebar") $manifest .= '		<![CDATA[</div>]]>';
		$manifest .= '		</field>'.CRLF;

		$manifest .= '	</fieldset>'.CRLF;
	}
	$manifest .= '</config>'.CRLF;

	return $manifest;
}


function SNS_icons_DataSet($data){
	$cfg = Setting::fetchConfigVal($data);
	return true;
}

?>